unit SOAPClientU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Rio, SoapHTTPClient, StdCtrls;

type
  TForm1 = class(TForm)
    HTTPRIO1: THTTPRIO;
    edtRadius: TEdit;
    lblCircleArea: TLabel;
    lblSphereVolume: TLabel;
    procedure edtRadiusChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SOAPIntf;

{$R *.dfm}

procedure TForm1.edtRadiusChange(Sender: TObject);
var
  Radius: Extended;
  Geometry: IGeometry;
begin
  Radius := StrToFloatDef( edtRadius.Text, -1 );
  if Radius = -1 then
  begin
    lblCircleArea.Caption := 'N/A';
    lblSphereVolume.Caption := 'N/A'
  end
  else
  begin
    Geometry := HTTPRIO1 as IGeometry;
    lblCircleArea.Caption := FloatToStr( Geometry.CircleArea( Radius ) );
    lblSphereVolume.Caption := FloatToStr( Geometry.SphereVolume( Radius ) );
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  edtRadiusChange(edtRadius);
end;

end.
