unit XMLEgU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, ComCtrls, msxmldom, XMLDoc;

type
  TForm1 = class(TForm)
    XMLDocument: TXMLDocument;
    XMLTree: TTreeView;
    procedure FormCreate(Sender: TObject);
  private
    procedure AddChildrenOf(XMLNode: IXMLNode; TreeNode: TTreeNode);
    function GetSomeText(Node: IXMLNode): String;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AddChildrenOf(XMLNode: IXMLNode; TreeNode: TTreeNode);
var
  I: Integer;
  ChildNode: IXMLNode;
  ChildTreeNode: TTreeNode;
begin
  for I := 0 to XMLNode.AttributeNodes.Count - 1 do
  begin
    ChildNode := XMLNode.AttributeNodes.Nodes[I];
    ChildTreeNode := XMLTree.Items.AddChild(TreeNode, GetSomeText(ChildNode));
    AddChildrenOf(ChildNode, ChildTreeNode)
  end;
  for I := 0 to XMLNode.ChildNodes.Count - 1 do
  begin
    ChildNode := XMLNode.ChildNodes.Nodes[I];
    ChildTreeNode := XMLTree.Items.AddChild(TreeNode, GetSomeText(ChildNode));
    AddChildrenOf(ChildNode, ChildTreeNode)
  end;
end;

function TForm1.GetSomeText(Node: IXMLNode): String;
begin
  if Node.IsTextElement then
    Result := Format('%s: %s', [Node.NodeName, Node.NodeValue])
  else
    Result := Node.NodeName
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Node: IXMLNode;
begin
  Node := XMLDocument.DocumentElement;
  AddChildrenOf(Node, XMLTree.Items.Add(nil, GetSomeText(Node)));
end;

end.
